function [ im_2D ] = FourierSlice4D( im_4D, alpha, width, height, radius)

% This function was written by Zhan Yu (https://www.eecis.udel.edu/~zyu/)
% for the purposes of implementation of light field refocusing via
% Fourier slicing. Some modifications have been made by me.
% 
%d = size(im_4D);

%im_4D = padarray(im_4D(:,:,:,:),d(1:4),0,'post');

Basis = [ 1 0 -alpha 0 ; 0 1 0 alpha ; 0 0 1 0 ; 0 0 0 1 ];

%Basis = [alpha 0 1-alpha 0; 0 alpha 0 1-alpha; 0 0 1 0; 0 0 0 1];

Basis_f = inv(Basis);

Basis_f = transpose(Basis_f);

d = det(Basis_f);

Basis_f= Basis_f/d;

%Basis_f=eye(4,4);

im_4D = ifftshift(im_4D);

im_f=fftn( im_4D );

%im_f_2=im_f;

im_f=fftshift( im_f );

dims=size( im_4D );

% Padding matrix
%im_f = padarray(im_f,[24 32]);

%height = dims(1);
%width = dims(2);

im_f_2D=zeros([height, width]);

offsetX = 10;
offsetY = 0;

divFact = 2;

offset = [0; 0; (dims(3))/divFact; (dims(4))/divFact]-Basis_f*[(dims(1))/divFact; (dims(2))/divFact; 0 ; 0];
offset(1,1)=0;
offset(2,1)=0;

%offset = int32(offset);
%offset = double(offset);


for T=1:height
    
    fprintf('%d/%d\n', T, height);
    
    for S=1:width

        %vc=[T; S; 9-(T-121)*alpha; 9+(S-161)*alpha];
        %vc=[T; S; 9-(T-dims(1)/2)*alpha; 9+(S-dims(2)/2)*alpha];
        
%         vc=double(zeros(4,1));
%         vc(1,1)=T*dims(1)/height;
%         vc(2,1)=S*dims(2)/width;
%         vc(3,1)=double(int32((dims(3)+1)/2));
%         vc(4,1)=double(int32((dims(4)+1)/2));
        
        vc=double(zeros(4,1));
        vc(1,1)=T*dims(1)/height;
        vc(2,1)=S*dims(2)/width;
        vc(3,1)=1;
        vc(4,1)=1;
        
        %vc(3,1)=double(int32((dims(3)+1)/2))+double((T-int32((height+1)/2)))*alpha;
        %vc(4,1)=double(int32((dims(4)+1)/2))-double((S-int32((width+1)/2)))*alpha;
        
        %vc=[T;S;dims(3)/2+1;dims(4)/2+1]; 
%         
        vc = Basis_f*vc;
       
        vc = vc+offset;
        
        %vc=uint32(vc);
       
        flag=uint32(0);
        
        if(vc(1,1)<1)
            vc(1,1)=1;
            %vc(1,1)=vc(1,1)+240;
            flag=uint32(1);
        end
        if(vc(1,1)>dims(1))
            vc(1,1)=dims(1);
            flag=uint32(1);
        end
        
        if(vc(2,1)<1)
            vc(2,1)=1;
            %vc(2,1)=vc(2,1)+320;
            flag=uint32(1);
        end
        if(vc(2,1)>dims(2))
            vc(2,1)=dims(2);
            flag=uint32(1);
        end

        if(vc(3,1)<1)
            %vc(3,1)=vc(3,1)+16;
            vc(3,1)=1;
            flag=uint32(1);
        end
        if(vc(3,1)>dims(3))
            %vc(3,1)=vc(3,1)-16;
            vc(3,1)=dims(3);
            flag=uint32(1);
        end
        
        if(vc(4,1)<1)
            %vc(4,1)=vc(4,1)+16;
            vc(4,1)=1;
            flag=uint32(1);
        end
        if(vc(4,1)>dims(4))
            %vc(4,1)=vc(4,1)-16;
            vc(4,1)=dims(4);
            flag=uint32(1);
        end
      
        if flag==0
            im_f_2D(T,S) = SampleGaussian2(im_f, vc(1,1), vc(2,1), vc(3,1), vc(4,1), radius);
            %vc=uint32(vc);
            %im_f_2D(T,S)=im_f(vc(1,1), vc(2,1), vc(3,1), vc(4,1));
        else
            im_f_2D(T,S)=0;
        end
       
        %im_f_2D(T,S)=im_f(vc(1,1), vc(2,1), vc(3,1), vc(4,1));
%         if flag==0
%             im_f_2D(T,S)=im_f(vc(1,1), vc(2,1), vc(3,1), vc(4,1));
%         else
%             im_f_2D(T,S)=0;
%         end

    end
end

%figure
%imshow(log(abs(im_f_2D)), []);

im_f_2D = ifftshift( im_f_2D );

im_2D=fftshift(ifftn(im_f_2D));

%figure
%imshow(im_2D, []);

end

function [clr] = SampleGaussian2( im, fy, fx, fv, fu, radius)

total_clr = 0;
total_weight = 0;

dims = size(im);

startx = max(1, uint32(fx)-1);
starty = max(1, uint32(fy)-1);
startu = max(1, uint32(fu)-radius);
startv = max(1, uint32(fv)-radius);

endx = min(dims(2), startx+1);
endy = min(dims(1), starty+1);
endu = min(dims(4), startu+radius);
endv = min(dims(3), startv+radius);

for v = startv:endv
    for u = startu:endu
        for y = starty:endy
            for x = startx:endx
                distance1 = (fy-double(y))*(fy-double(y))+(fx-double(x))*(fx-double(x));
                distance2 = (fv-double(v))*(fv-double(v))+(fu-double(u))*(fu-double(u));
                
                weight1 = exp(-distance1);
                weight2 = exp(-distance1*9/radius/radius);
                weight = weight1*weight2;
                
                total_weight = total_weight+weight;
                
                current_clr = im(y,x,v,u);
                
                total_clr = total_clr+current_clr*weight;
            end
        end
    end
end

clr = total_clr/total_weight;

end

function [clr] = SampleGaussian( im, fy, fx, fv, fu, radius)

total_clr = 0;
total_weight = 0;

dims = size(im);

startu = max(1, uint32(fu)-radius);
startv = max(1, uint32(fv)-radius);

endu = min(dims(4), startu+radius);
endv = min(dims(3), startv+radius);

for v = startv:endv
    for u = startu:endu
                distance = (fv-double(v))*(fv-double(v))+(fu-double(u))*(fu-double(u));
                
                weight = exp(-distance*9/radius/radius);
                
                total_weight = total_weight+weight;
                
                current_clr = im(floor(fy+0.5),floor(fx+0.5),v,u);
                
                total_clr = total_clr+current_clr*weight;
    end
end

clr = total_clr/total_weight;

end